// =============================================================================
// CGM AUTOMAO - INTELIGNCIA EM SOFTWARE
// =============================================================================

// =============================================================================
// Unit de Funes de JavaScript usadas nos artigos de IntraWeb em
// http://www.cgmautomacao.com.br
// =============================================================================

unit FUNCOES_JAVASCRIPT;

interface

uses
    Classes, SysUtils, IWControl, IWAppForm, IWApplication, IWTypes,
    IWHTMLControls;

type
    //CRIE NOVAS MSCARAS, CONFORME NECESSIDADE
    TMascara = (maskDATA, maskHORA);

    procedure InsereJavaScript(Script: string; aIWForm: TIWAppForm);
    procedure InsereJavaScriptExterno(Arquivo: string; aIWForm: TIWAppForm);

    function JavaScriptTAG(Script: string): string;
    function jQuerySelect(Components: array of TIWCustomControl): string;

    function jQueryMask(Components: array of TIWCustomControl;
      Mascara: TMascara): string; overload;
    function jQueryMask(Components: array of TIWCustomControl;
      Mascara: string; DefinicaoMascara: string = ''): string; overload;

implementation

uses IWBaseForm;

procedure InsereJavaScript(Script: string; aIWForm: TIWAppForm);
begin
  aIWForm.ExtraHeader.Add(Script);
end;

procedure InsereJavaScriptExterno(Arquivo: string; aIWForm: TIWAppForm);
begin
  aIWForm.ExtraHeader.Add(
    '<script src='+ QuotedStr(Arquivo) + ' type="text/javascript"></script>');
end;

function JavaScriptTAG(Script: string): string;
begin
  Result :=
    '<script type="text/javascript">'
     + Script +
    '</script>'
end;

function jQuerySelect(Components: array of TIWCustomControl): string;
var
  i: Integer;
  sel: string;
  comp: string;
begin
  sel := '$("';
  for i := Low(Components) to High(Components) do
  begin
    comp := '#'+UpperCase(Components[i].Name);
    sel := sel + comp;
    if i < High(Components) then
      sel := sel + ',';
  end;
  sel := sel + '")';
  Result := sel;
end;

function jQueryMask(Components: array of TIWCustomControl;
  Mascara: TMascara): string;

  function RetornaDefinicaoMascara: string;
  begin
    //VOC PODE CRIAR NOVAS DEFINIES DE MSCARAS
    //DEFININDO QUAIS VALORES PODEM SER
    //ONDE ["SIMBOLO"]="[VALOR DE ENTRADA PERMITIDO]"
    case Mascara of
      maskDATA:
          Result := '$.mask.definitions["#"]="[0-3]";'+
                    '$.mask.definitions["!"]="[0-1]";'+
                    '$.mask.definitions["@"]="[0-2]";';
      maskHORA:
          Result := '$.mask.definitions["@"]="[0-2]";'+
                    '$.mask.definitions["#"]="[0-3]";'+
                    '$.mask.definitions["%"]="[0-5]";';
      else Result := '';
    end;
  end;

  function RetornaMascara: string;
  begin
    //VOC PODE CRIAR NOVAS MSCARAS,
    //USANDO NOVAS DEFINIES OU AS PADRO:
    //a - carcter alfa (A-Z,a-z)
    //9 - carcter numrico (0-9)
    //* - carcter alfanumrico (A-Z,a-z,0-9)
    case Mascara of
      maskDATA: Result := '#9/!9/@999';
      maskHORA: Result := '@#:%9';
    end;
  end;

begin
  Result := jQueryMask(Components, RetornaMascara, RetornaDefinicaoMascara);
end;

function jQueryMask(Components: array of TIWCustomControl; Mascara: string;
  DefinicaoMascara: string): string;
begin
  Result := JavaScriptTAG(
    'jQuery(function(){'
     + DefinicaoMascara
     + jQuerySelect(Components) + '.mask("' + Mascara + '");})');
end;

end.
